'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
var goober = require('goober');

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

function _taggedTemplateLiteralLoose(strings, raw) {
  if (!raw) {
    raw = strings.slice(0);
  }

  strings.raw = raw;
  return strings;
}

var usePreserve = function usePreserve(value) {
  var ref = React.useRef();
  var preservedValue = value || ref.current;

  if (value) {
    ref.current = value;
  }

  return preservedValue;
};

(function (StatusType) {
  StatusType["Error"] = "error";
  StatusType["Loading"] = "loading";
  StatusType["Success"] = "success";
  StatusType["Custom"] = "custom";
})(exports.StatusType || (exports.StatusType = {}));

var defaultTimeouts = /*#__PURE__*/new Map([[exports.StatusType.Error, 4000], [exports.StatusType.Success, 1500], [exports.StatusType.Loading, 30000]]);

function _templateObject4() {
  var data = _taggedTemplateLiteralLoose(["\n  width: 20px;\n  opacity: 0;\n  height: 20px;\n  border-radius: 10px;\n  background-color: #ff4b4b;\n  position: relative;\n  transform: rotate(45deg);\n\n  animation: ", " 0.3s cubic-bezier(0.175, 0.885, 0.32, 1.275)\n    forwards;\n  animation-delay: ", "ms;\n\n  &:after,\n  &:before {\n    content: '';\n    animation: ", " 0.15s ease-out forwards;\n    animation-delay: ", "ms;\n    position: absolute;\n    border-radius: 3px;\n    opacity: 0;\n    background: white;\n    bottom: 9px;\n    left: 4px;\n    height: 2px;\n    width: 12px;\n  }\n\n  &:before {\n    animation: ", " 0.15s ease-out forwards;\n    animation-delay: ", "ms;\n    transform: rotate(90deg);\n  }\n"]);

  _templateObject4 = function _templateObject4() {
    return data;
  };

  return data;
}

function _templateObject3() {
  var data = _taggedTemplateLiteralLoose(["\n  from {\n    transform: scale(0) rotate(90deg);\n\t opacity: 0;\n  }\n\n  to {\n    transform: scale(1) rotate(90deg);\n\t opacity: 1;\n  }\n"]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = _taggedTemplateLiteralLoose(["\n  from {\n    transform: scale(0);\n\t opacity: 0;\n  }\n\n  to {\n    transform: scale(1);\n\t opacity: 1;\n  }\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = _taggedTemplateLiteralLoose(["\n  from {\n    transform: scale(0) rotate(45deg);\n\t opacity: 0;\n  }\n\n  to {\n    transform: scale(1) rotate(45deg);\n\t opacity: 1;\n  }\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}
var circleAnimation = /*#__PURE__*/goober.keyframes( /*#__PURE__*/_templateObject());
var firstLineAnimation = /*#__PURE__*/goober.keyframes( /*#__PURE__*/_templateObject2());
var secondLineAnimation = /*#__PURE__*/goober.keyframes( /*#__PURE__*/_templateObject3());
var ErrorIndicator = /*#__PURE__*/goober.styled('div')( /*#__PURE__*/_templateObject4(), circleAnimation, function (p) {
  return p.delay || 0;
}, firstLineAnimation, function (p) {
  return (p.delay || 0) + 50;
}, secondLineAnimation, function (p) {
  return (p.delay || 0) + 80;
});

function _templateObject2$1() {
  var data = _taggedTemplateLiteralLoose(["\n  width: 12px;\n  height: 12px;\n  box-sizing: border-box;\n  border: 2px solid;\n  border-radius: 100%;\n  border-color: #e0e0e0;\n  border-right-color: #616161;\n  animation: ", " 1s linear infinite;\n"]);

  _templateObject2$1 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject$1() {
  var data = _taggedTemplateLiteralLoose(["\n  from {\n    transform: rotate(0deg);\n  }\n\n  to {\n    transform: rotate(360deg);\n  }\n"]);

  _templateObject$1 = function _templateObject() {
    return data;
  };

  return data;
}
var rotate = /*#__PURE__*/goober.keyframes( /*#__PURE__*/_templateObject$1());
var Loader = /*#__PURE__*/goober.styled('div')( /*#__PURE__*/_templateObject2$1(), rotate);

function _templateObject3$1() {
  var data = _taggedTemplateLiteralLoose(["\n  width: 20px;\n  opacity: 0;\n  height: 20px;\n  border-radius: 10px;\n  background-color: #61d345;\n  position: relative;\n  transform: rotate(45deg);\n\n  animation: ", " 0.3s cubic-bezier(0.175, 0.885, 0.32, 1.275)\n    forwards;\n  animation-delay: ", "ms;\n  &:after {\n    content: '';\n    box-sizing: border-box;\n    visibility: hidden;\n    animation: ", " 0.2s ease-out forwards;\n    animation-delay: ", "ms;\n    position: absolute;\n    border-right: 2px solid;\n    border-bottom: 2px solid;\n    border-color: white;\n    bottom: 6px;\n    left: 6px;\n    height: 10px;\n    width: 6px;\n  }\n"]);

  _templateObject3$1 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2$2() {
  var data = _taggedTemplateLiteralLoose(["\n  0% {\n\t\theight: 0;\n\t\twidth: 0;\n\t\topacity: 0;\n\t\tvisibility: visible;\n  }\n\n  40% {\n\t\theight: 0;\n\t\twidth: 6px;\n\t\topacity: 1;\n  }\n\n  100% {\n\tvisibility: visible;\n\t\theight: 10px;\n  }\n"]);

  _templateObject2$2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject$2() {
  var data = _taggedTemplateLiteralLoose(["\n  from {\n    transform: scale(0) rotate(45deg);\n\t opacity: 0;\n  }\n\n  to {\n    transform: scale(1) rotate(45deg);\n\t opacity: 1;\n  }\n"]);

  _templateObject$2 = function _templateObject() {
    return data;
  };

  return data;
}
var circleAnimation$1 = /*#__PURE__*/goober.keyframes( /*#__PURE__*/_templateObject$2());
var checkmarkAnimation = /*#__PURE__*/goober.keyframes( /*#__PURE__*/_templateObject2$2());
var Checkmark = /*#__PURE__*/goober.styled('div')( /*#__PURE__*/_templateObject3$1(), circleAnimation$1, function (p) {
  return p.delay || 0;
}, checkmarkAnimation, function (p) {
  return (p.delay || 0) + 100;
});

function _templateObject2$3() {
  var data = _taggedTemplateLiteralLoose(["\n  position: relative;\n"]);

  _templateObject2$3 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject$3() {
  var data = _taggedTemplateLiteralLoose(["\n  position: absolute;\n  left: -4px;\n  top: -4px;\n"]);

  _templateObject$3 = function _templateObject() {
    return data;
  };

  return data;
}
var StatusWrapper = /*#__PURE__*/goober.styled('div')( /*#__PURE__*/_templateObject$3());
var IndicatorWrapper = /*#__PURE__*/goober.styled('div')( /*#__PURE__*/_templateObject2$3());
var Indicator = function Indicator(_ref) {
  var statusType = _ref.statusType,
      done = _ref.done,
      delay = _ref.delay;
  var notLoading = statusType !== undefined && statusType !== exports.StatusType.Loading || done;
  return React.createElement(IndicatorWrapper, null, React.createElement(Loader, null), notLoading && React.createElement(StatusWrapper, null, statusType === exports.StatusType.Error ? React.createElement(ErrorIndicator, {
    delay: delay
  }) : React.createElement(Checkmark, {
    delay: delay
  })));
};

function _templateObject8() {
  var data = _taggedTemplateLiteralLoose(["\n  position: relative;\n  transform: scale(0.6);\n  opacity: 0.4;\n  animation: ", " 0.3s cubic-bezier(0.175, 0.885, 0.32, 1.275)\n    forwards;\n  animation-delay: 0.12s;\n"]);

  _templateObject8 = function _templateObject8() {
    return data;
  };

  return data;
}

function _templateObject7() {
  var data = _taggedTemplateLiteralLoose(["\n  from {\n    transform: scale(0.6);\n\t opacity: 0.4;\n  }\n\n  to {\n    transform: scale(1);\n\t opacity: 1;\n  }\n"]);

  _templateObject7 = function _templateObject7() {
    return data;
  };

  return data;
}

function _templateObject6() {
  var data = _taggedTemplateLiteralLoose(["\n  margin: 4px;\n  margin-left: 10px;\n  color: #363636;\n  flex: 1;\n  text-align: center;\n"]);

  _templateObject6 = function _templateObject6() {
    return data;
  };

  return data;
}

function _templateObject5() {
  var data = _taggedTemplateLiteralLoose(["\n  /* display: absolute; */\n"]);

  _templateObject5 = function _templateObject5() {
    return data;
  };

  return data;
}

function _templateObject4$1() {
  var data = _taggedTemplateLiteralLoose(["\n  display: flex;\n  position: absolute;\n  align-items: center;\n  background: white;\n  max-width: 300px;\n  box-shadow: 0 3px 10px rgba(0, 0, 0, 0.1), 0 3px 3px rgba(0, 0, 0, 0.05);\n  padding: 6px 12px;\n  margin-top: 20px;\n  border-radius: 8px;\n"]);

  _templateObject4$1 = function _templateObject4() {
    return data;
  };

  return data;
}

function _templateObject3$2() {
  var data = _taggedTemplateLiteralLoose(["", ""]);

  _templateObject3$2 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2$4() {
  var data = _taggedTemplateLiteralLoose(["", ""]);

  _templateObject2$4 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject$4() {
  var data = _taggedTemplateLiteralLoose(["\n  position: fixed;\n  display: flex;\n  justify-content: center;\n  left: 0;\n  right: 0;\n  top: 0;\n"]);

  _templateObject$4 = function _templateObject() {
    return data;
  };

  return data;
}
var StatusBarWrapper = /*#__PURE__*/goober.styled('div')( /*#__PURE__*/_templateObject$4());
var enterSpring = "\n0% {transform: translate3d(0,-80px,0) scale(0.6); opacity:.5;}\n100% {transform: translate3d(0,0,0) scale(1); opacity:1;}\n";
var enterAnimation = {
  zIndex: 2,
  animation: /*#__PURE__*/goober.keyframes( /*#__PURE__*/_templateObject2$4(), enterSpring) + " forwards",
  animationDuration: '0.3s',
  animationTimingFunction: 'cubic-bezier(.21,1.02,.73,1)'
};
var exitSpring = "\n0% {transform: translate3d(0, 0, 0) scale(1); opacity: 1;}\n100% {transform: translate3d(0,-130px, 0) scale(0.5); opacity: 0;}\n";
var exitAnimation = {
  animation: /*#__PURE__*/goober.keyframes( /*#__PURE__*/_templateObject3$2(), exitSpring) + " 0.5s forwards cubic-bezier(.06,.71,.55,1)"
}; // Animated

var StatusBarBase = /*#__PURE__*/goober.styled('div', React.forwardRef)( /*#__PURE__*/_templateObject4$1());
var IndicatorWrapper$1 = /*#__PURE__*/goober.styled('div')( /*#__PURE__*/_templateObject5());
var Message = /*#__PURE__*/goober.styled('p')( /*#__PURE__*/_templateObject6());
var firstLineAnimation$1 = /*#__PURE__*/goober.keyframes( /*#__PURE__*/_templateObject7());
var CustomIndicator = /*#__PURE__*/goober.styled('div')( /*#__PURE__*/_templateObject8(), firstLineAnimation$1);
var StatusBar = /*#__PURE__*/React.memo(function (_ref) {
  var status = _ref.status,
      onHeight = _ref.onHeight,
      offset = _ref.offset;
  var persStatus = usePreserve(status);
  var ref = React.useCallback(function (el) {
    if (el) {
      var boundingRect = el.getBoundingClientRect();
      onHeight(boundingRect.height);
    }
  }, []);
  return React.createElement("div", null, React.createElement(StatusBarWrapper, {
    key: "status-bar",
    style: {
      transition: 'all 200ms cubic-bezier(0.59,0,0.5,1.15)',
      transform: "translateY(" + offset + "px)"
    }
  }, React.createElement(StatusBarBase, {
    ref: ref,
    style: persStatus != null && persStatus.height ? persStatus.visible ? enterAnimation : exitAnimation : {
      opacity: 0
    }
  }, React.createElement(IndicatorWrapper$1, null, (persStatus == null ? void 0 : persStatus.type) === exports.StatusType.Custom ? React.createElement(CustomIndicator, null, "\uD83D\uDD25") : React.createElement(Indicator, {
    statusType: persStatus == null ? void 0 : persStatus.type,
    delay: 100
  })), React.createElement(Message, {
    role: "alert",
    "aria-live": "polite"
  }, persStatus == null ? void 0 : persStatus.message, " ", persStatus == null ? void 0 : persStatus.id))));
});

var genId = /*#__PURE__*/function () {
  var count = 0;
  return function () {
    return ++count;
  };
}();

var TOAST_LIMIT = 20;

var addReducer = function addReducer(queue, status) {
  if (queue.find(function (s) {
    return s.id === status.id;
  })) {
    return queue.map(function (s) {
      return s.id === status.id ? _extends({}, s, status) : s;
    });
  } else {
    return [status].concat(queue).slice(0, TOAST_LIMIT);
  }
};

var hideReducer = function hideReducer(queue, status) {
  return queue.map(function (s) {
    return s.id === status.id && s.createdAt === status.createdAt ? _extends({}, status, {
      visible: false
    }) : s;
  });
};

var addPauseReducer = function addPauseReducer(queue, pause) {
  return queue.map(function (s) {
    return _extends({}, s, {
      timeout: s.timeout + pause
    });
  });
};

var listeners = [];
var memoryQueue = [];

var createHandler = function createHandler(type) {
  return function (message, options) {
    return setNotification(_extends({
      id: genId(),
      createdAt: Date.now(),
      visible: true,
      timeout: defaultTimeouts.get(type) || 3000,
      message: message,
      type: type
    }, options));
  };
};

var notify = {
  success: /*#__PURE__*/createHandler(exports.StatusType.Success),
  error: /*#__PURE__*/createHandler(exports.StatusType.Error),
  loading: /*#__PURE__*/createHandler(exports.StatusType.Loading),
  custom: /*#__PURE__*/createHandler(exports.StatusType.Custom)
};
var setNotification = function setNotification(status) {
  memoryQueue = addReducer(memoryQueue, status);
  listeners.forEach(function (listener) {
    listener(status);
  });
  return status.id;
};
var notifyPromise = function notifyPromise(promise, _ref) {
  var loading = _ref.loading,
      success = _ref.success,
      error = _ref.error;
  var id = notify.loading(loading);
  promise.then(function (p) {
    notify.success(typeof success === 'function' ? success(p) : success, {
      id: id
    });
    return p;
  })["catch"](function (e) {
    notify.error(typeof error === 'function' ? error(e) : error, {
      id: id
    });
  });
  return promise;
};
var useToasts = function useToasts() {
  var _useState = React.useState(memoryQueue),
      queue = _useState[0],
      setQueue = _useState[1];

  var _useState2 = React.useState(false),
      pauseAt = _useState2[0],
      setPausedAt = _useState2[1];

  React.useEffect(function () {
    var handler = function handler(status) {
      setQueue(addReducer(queue, status));
    };

    listeners.push(handler);
    return function () {
      var index = listeners.indexOf(handler);

      if (index > -1) {
        listeners.splice(index, 1);
      }
    };
  }, [queue]);
  React.useEffect(function () {
    if (pauseAt) {
      return;
    }

    var now = Date.now();
    var timeouts = queue.map(function (s) {
      var duration = s.timeout - (now - s.createdAt);

      if (duration < 0) {
        if (s.visible) {
          setQueue(hideReducer(queue, s));
        }

        return;
      }

      return setTimeout(function () {
        setQueue(hideReducer(queue, s));
      }, duration);
    });
    return function () {
      timeouts.forEach(function (timeout) {
        return timeout && clearTimeout(timeout);
      });
    };
  }, [queue, pauseAt]);
  var handlers = React.useMemo(function () {
    return {
      onMouseEnter: function onMouseEnter() {
        setPausedAt(Date.now());
      },
      onMouseLeave: function onMouseLeave() {
        if (pauseAt) {
          var diff = Date.now() - pauseAt;
          setQueue(addPauseReducer(queue, diff));
          setPausedAt(false);
        }
      }
    };
  }, [queue, pauseAt]);
  return [queue, handlers];
};

goober.setup(React.createElement);
var MARGIN = 8;
var ToastsContainer = function ToastsContainer() {
  var _useToasts = useToasts(),
      toasts = _useToasts[0],
      handlers = _useToasts[1];

  var visibleToasts = toasts.filter(function (t) {
    return t.height && t.visible;
  });
  return React.createElement("div", Object.assign({}, handlers), toasts.map(function (s) {
    var index = visibleToasts.findIndex(function (toast) {
      return toast.id === s.id;
    });
    var offset = visibleToasts.slice(index + 1).reduce(function (acc, s) {
      return acc + (s.height || 0) + MARGIN;
    }, 0);
    return React.createElement(StatusBar, {
      onHeight: function onHeight(height) {
        return setNotification(_extends({}, s, {
          height: height
        }));
      },
      key: s.id,
      status: s,
      offset: offset
    });
  }));
};

exports.StatusBar = StatusBar;
exports.ToastsContainer = ToastsContainer;
exports.notify = notify;
exports.notifyPromise = notifyPromise;
//# sourceMappingURL=react-hot-toast.cjs.development.js.map
